
#define MPG123_STATIC
#include once "mpg123_1.23.0.bi"

#define OUT123_STATIC
#include once "out123_1.23.0.bi"

sub _init constructor
  mpg123_init()
end sub

sub _exit destructor
  mpg123_exit()
end sub

'
' main
'
ChDir ExePath()
var hDecoder = mpg123_new(NULL,NULL)
if hDecoder then
  mpg123_reset_eq(hDecoder)
  if mpg123_open(hDecoder,"legends.mp3") = MPG123_OK then
    var hOut = out123_new()
    if (hOut<>NULL) then
      if out123_open(hOut,NULL,NULL)=0 then
         dim as long rate,channels,encod
         if mpg123_getformat(hDecoder, @rate, @channels, @encod) = MPG123_OK then
           dim as zstring ptr driver = NULL
           if out123_driver_info(hOut, @driver,NULL) = OUT123_OK then
             print "using driver: " & *driver
             mpg123_format_none(hDecoder)
             mpg123_format(hDecoder, rate, channels, encod)
             if out123_start(hOut, rate, channels, encod) = OUT123_OK  then
               dim as long framesize
               if out123_getformat(hOut, NULL, NULL, NULL, @framesize) = OUT123_OK  then
                 var BufferSize = mpg123_outblock(hDecoder)
                 var Buffer = allocate(BufferSize)
                 dim as long errCode,done
                 dim as off_t samples 
                 print "playing: press [ctrl] & [c] ..."
                 do
                   errCode = mpg123_read(hDecoder, Buffer, BufferSize, @done)
                   dim as size_t played = out123_play(hOut, Buffer, done)
                   samples += played/framesize
                   if (played <> done) then
                     print "warning: played: " & played & "  decoded: " & done
                   end if
                 loop while ( (done>0) andalso (errCode=MPG123_OK))
                 deallocate buffer
               else
                 print "out123_getformat() failed !"
               end if
               out123_stop(hOut)
             else
               print "out123_start() failed !"
             end if
           else
             print "out123_driver_info() failed !"
           end if 
         else
           print "mpg123_getformat_open() failed !"
         end if
         print "out123_close()"
         out123_close(hOut)
      else
        print "out123_open() failed !"
      end if
      print "out123_del()"
      out123_del hOut
      hOut=NULL
    else
      print "out123_new() failed !"
      beep : sleep : end 1
    end if
    print "mpg123_close()"
    mpg123_close(hDecoder)
  else
    print "mpg123_open() failed !"
    beep : sleep : end 1
  end if
  print "mpg123_delete()"
  mpg123_delete(hDecoder)
  hDecoder=NULL
else
  print "mpg123_new() failed !"
  beep : sleep : end 1
end if





